%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PVC:SYS-CONSTS.SL
% Description:  DEC Alpha PSL constants needed in the compiler
% Author:       Winfried Neun
% Created:      24-Jan-93
% Mode:         Lisp
% Package:      
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1993 , Konrad Zuse Zentrum Berlin, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(imports '(tags))

(fluid '(system_list*))

(setq system_list* '(alpha IEEE Unix OSF little_endian))

(define-constant faslin-magic  199)
(define-constant faslout-magic 199)

(define-constant tagstartingbit                  0)
(define-constant tagbitlength                    8)
(define-constant infstartingbit                  8)
(define-constant infbitlength                   56)
(define-constant addressingunitsperitem 	 8)
(define-constant charactersperword               8)
(define-constant bitsperword                    64)
(define-constant bitsperword2                   16)
(define-constant stackdirection                 -1)
(define-constant addressingunitsperfunctioncell  8)


(define-constant maxrealregs  5)
(define-constant maxargs      15)

% At present this is the single machine-dependent character
% (for ASCII machines).  Defined here in case cross-compilation
% is being done.  Defined for the kernel in pv:scan-table.sl. /csp
(put 'eof 'charconst (char (control d)))

(define-constant stacksize             20000)
(define-constant bndstksize            2000)
(define-constant compressedbinaryradix 16)
(define-constant maxtokensize          5000)
(define-constant catchstacksize        400)
(define-constant hash-table-size       18013)
(define-constant maxsymbols            15000)
%(define-constant heapsize              800000)  % These are now taken care of
%(define-constant bpssize               500000)  % by $pv/bpsheap.c

% End of file.
