%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXK:SYS-SUPPORT.SL
% Description:  Sparc-specific kernel support functions
% Author:       Chris Burdorf
% Created:      10-May-88
% Modified:       
% Mode:         Lisp
% Package:      
% Status:       Experimental (Do Not Distribute)
%
%               Changes to All functions by W. Neun, ZIB Berlin, Nov-15-88
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(lap '((*entry compiledcallinginterpreted expr 0)
	(*alloc 0)
	(L   (reg t1) (lit "    .long symfnc #"))
        (*dealloc 0)
        (L   (reg r7) (xdisplacement (reg t1)
				compiledcallinginterpretedaux))
        (BR  (reg r7))))

(lap '((*entry undefinedfunction expr 0)
        (*alloc 0)
        (L   (reg t1) (lit "    .long symfnc #"))
        (*dealloc 0)
        (L   (reg r7) (xdisplacement (reg t1)
                                undefinedfunctionaux))
        (BR  (reg r7))))

(lap '((*entry undefinedfunctionaux expr 0)
      
       %. Error Handler for non code                                       
       %                                                                   
       % (reg t1) <- caller's address                                      
       %                                                                   
       (*move (reg t2) (reg 1))
       (*wshift (reg 1) 2)
       (*alloc 1)
       (*move (reg 1) (frame 1))
       (*move (quote "Undefined function called: ") (reg 1))
       (*call console-print-string)
       (*move (frame 1) (reg 1))
       (*wplus2 (Reg 1) (fluid symnam)) %add offset to symnam
				     % to get real address of name.
       (*move (displacement (reg 1) 0) (reg 1))  %move string object to r1
       (*call console-print-string)
       (*move (wconst -1) (reg 1))
       (*linke 1 exit-to-caller expr 1)))


(de kernel-fatal-error (message)
  (console-print-string "FATAL ERROR:") 
  (console-print-string message)
  (console-newline)
  (exit-to-caller -1)
  )

(de exit-to-caller (sta)
   (external_exit sta))

(compiletime (lap (append '((*entry plantunbound expr 1)
       (*alloc 0)
	(balr (reg r7) (reg r0))
    base_plantunbound
       (*move (reg 1) (reg 5))                    %% the id number
       (sll (reg 1) 2)
       (*wplus2  (reg 1) (fluid symfnc))               %% get cell
       (L (reg 2) (displacement (reg r7)
		(difference undefinedfunctioninstruction base_plantunbound)))
   %% get address of entry
       (st (reg 2) (displacement (reg 1) 0))       %%
       (*exit 0)
       (!.align  4)
    undefinedfunctioninstruction)
      (list
       (bldmsg "   .long %w" (get 'undefinedfunction 'entrypoint))))))

(compiletime (lap (append '((*entry plantlambdalink expr 1)
       (*alloc 0)
        (balr (reg r7) (reg r0))
    base_lambdalink
       (*move (reg 1) (reg 5))                    %% the id number
       (sll (reg 1) 2)
       (*wplus2  (reg 1) (fluid symfnc))               %% get cell
       (L (reg 2) (displacement (reg r7) 
                (difference lambdalinkinstruction base_lambdalink)))   
   %% get address of entry
       (st (reg 2) (displacement (reg 1) 0))       %%
       (*exit 0)
       (!.align 4)
    lambdalinkinstruction)
       (list
       (bldmsg "   .long  %w" (get 'compiledcallinginterpreted 'entrypoint)
)))))

(lap '((*entry plantcodepointer expr 2)
       (*alloc 0)
       (sll (reg 1) 2)
       (*wplus2  (reg 1) (fluid symfnc))               %% get cell
       (st (reg 2) (displacement (reg 1) 0))       %%
       (*exit 0)))
