%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:           PXNK:LAP.SL
% Title:          LAP support for EVAL and APPLY
% Author:         Eric Benson
% Created:        20 August 1981
% Modified:       26 Jan 1984 1040-PST (Brian Beach)
% Status:         Experimental
% Mode:           Lisp
%
% (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
% (c) Copyright 1981, University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% November15 1989, Winfried  Neun, ZIB Berlin
% Version for Mips
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(global '(bndstkptr bndstkupperbound))

(compiletime (load sys-macros))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% if this could be written in Syslisp, it would look something like this:
%
% syslsp procedure CodeApply(CodePtr, ArgList);
% begin scalar N;
%     N := 0;
%     while PairP ArgList do
%     <<  N := N + 1;
%         ArgumentRegister[N] := car ArgList;
%         ArgList := cdr ArgList >>;
%     (jump to address of code pointer)
% end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(lap '((*entry codeapply expr 2)
       %
       % CodeApply(CodePointer, ArgList)
       %
       % (reg 1) is code pointer
       % (reg 2) is arg list
       %
       (*alloc 0)
       (and (reg t1) (reg 1) (reg infmask))% (reg t1) <- entry point.
       (*move (indexed (reg t1) 4) (reg t1))
       (srl (reg t1) (reg t1) 2)
       (*move (reg argtwo) (reg t5))       % (reg t5) <- arglist

       (*jumpeq (label CONTINUE) (reg t5) (reg nil))    % 0 argument

       (*move (car (reg t5)) (reg 1))
       (*move (cdr (reg t5)) (reg t5))
       (*jumpeq (label CONTINUE) (reg t5) (reg nil))

       (*move (car (reg t5)) (reg 2))
       (*move (cdr (reg t5)) (reg t5))
       (*jumpeq (label CONTINUE) (reg t5) (reg nil))

       (*move (car (reg t5)) (reg 3))
       (*move (cdr (reg t5)) (reg t5))
       (*jumpeq (label CONTINUE) (reg t5) (reg nil))

       (*move (car (reg t5)) (reg 4))
       (*move (cdr (reg t5)) (reg t6))
       (*jumpeq (label CONTINUE) (reg t6) (reg nil))

       (*move (car (reg t6)) (reg 5))
       (*move (cdr (reg t6)) (reg t6))
       (*jumpeq (label CONTINUE) (reg t6) (reg nil))

       (*move (car (reg t6)) (reg 6))
       (*move (cdr (reg t6)) (reg t6))
       (*jumpeq (label CONTINUE) (reg t6) (reg nil))

       (*move (car (reg t6)) (reg 7))
       (*move (cdr (reg t6)) (reg t6))
       (*jumpeq (label CONTINUE) (reg t6) (reg nil))

       (*move (car (reg t6)) (reg 8))
       (*move (cdr (reg t6)) (reg t6))
       (*jumpeq (label CONTINUE) (reg t6) (reg nil))

       (*move (car (reg t6)) (reg 9))
       (*move (cdr (reg t6)) (reg t6))
       (*jumpeq (label CONTINUE) (reg t6) (reg nil))

       (*move (car (reg t6)) (reg 10))
       (*move (cdr (reg t6)) (reg t6))
       (*jumpeq (label CONTINUE) (reg t6) (reg nil))

       (*move (car (reg t6)) (reg 11))
       (*move (cdr (reg t6)) (reg t6))
       (*jumpeq (label CONTINUE) (reg t6) (reg nil))

       (*move (car (reg t6)) (reg 12))
       (*move (cdr (reg t6)) (reg t6))
       (*jumpeq (label CONTINUE) (reg t6) (reg nil))

       (*move (car (reg t6)) (reg 13))
       (*move (cdr (reg t6)) (reg t6))
       (*jumpeq (label CONTINUE) (reg t6) (reg nil))

       (*move (car (reg t6)) (reg 14))
       (*move (cdr (reg t6)) (reg t6))
       (*jumpeq (label CONTINUE) (reg t6) (reg nil))

       (*move (car (reg t6)) (reg 15))
       (*move (cdr (reg t6)) (reg t6))
       (*jumpeq (label CONTINUE) (reg t6) (reg nil))

       (*move (car (reg t6)) (reg 16))
       (*move (cdr (reg t6)) (reg t6))
       (*jumpeq (label CONTINUE) (reg t6) (reg nil))

       (*move (quote "Too many arguments to function") (reg 1))
       (*dealloc 0)
       (*jcall stderror)
       
CONTINUE
       (*dealloc 0)
       (sll (reg t1) (reg t1) 2)
       (jr (reg t1))
       (nop)))
       

(de codeevalapply (codeptr arglist)
  (codeapply codeptr (evlis arglist)))

(de bindeval (formals args)
  (bindevalaux formals args 0))

(de bindevalaux (formals args n)
  (let (f
	a)
       (cond ((pairp formals) (if (pairp args)
	        (progn (setq f (first formals))
	               (setq a (eval (first args)))
	               (setq n
	                (bindevalaux (rest formals) (rest args) (iadd1 n)))
	               (if (weq n -1) -1
	                 (progn (lbind1 f a) n)))
	        -1))
	     ((pairp args) -1)
	     (t n))))


(lap '((*entry undefinedfunctionaux expr 0)
       %
       % Error handler for non-code.
       %
       %        call SYMFNC+X           ;; This function is undefined.
       %        move  t3,idnumber
       %        .............
       % SYMFNC+X:
       %        j UNDEFINEDFUNCTION
       %
       (*alloc 17)
       (*move (reg t3) (frame 1))   % Set continueable address
       (*move (reg 1)(frame 2))     % Save all the args (including fakes)
       (*move (reg 2)(frame 3))
       (*move (reg 3)(frame 4))
       (*move (reg 4)(frame 5))
       (*move (reg 5)(frame 6))
       (*move (reg 6)(frame 7))
       (*move (reg 7)(frame 8))
       (*move (reg 8)(frame 9))
       (*move (reg 9)(frame 10))
       (*move (reg 10)(frame 11))
       (*move (reg 11)(frame 12))
       (*move (reg 12)(frame 13))
       (*move (reg 13)(frame 14))
       (*move (reg 14)(frame 15))
       (*move (reg 15)(frame 16))
       (*move (reg 16)(frame 17))

       (*move (frame 1) (reg 2))
       (sll (reg 2) (reg 2) 2)
       (*mkitem (reg 2) (wconst id-tag))
       (*move (reg 2) (frame 1))
       (*move '"Undefined function %r called from compiled code" (reg 1))
       (*call bldmsg)
       (*move (reg 1) (reg 2))
       (*move (wconst 0) (reg 1))
       (*move (reg nil) (reg 3))
       (*call continuableerror)

       (*move (frame 17 ) (reg 16))    % Restore all those possible arguments
       (*move (frame 16 ) (reg 15))
       (*move (frame 15 ) (reg 14))
       (*move (frame 14 ) (reg 13))
       (*move (frame 13 ) (reg 12))
       (*move (frame 12 ) (reg 11))
       (*move (frame 11 ) (reg 10))
       (*move (frame 10 ) (reg 9))
       (*move (frame 9 ) (reg 8))
       (*move (frame 8 ) (reg 7))
       (*move (frame 7 ) (reg 6))
       (*move (frame 6 ) (reg 5))
       (*move (frame 5 ) (reg 4))
       (*move (frame 4 ) (reg 3))
       (*move (frame 3 ) (reg 2))
       (*move (frame 2 ) (reg 1))
       (*move (frame 1) (reg t1))
       (*dealloc 17)
       (*jcall fastapply)))

%
% This is pretty gross, but it is essentially the same as LambdaApply, taking
% values from the argument registers instead of a list.
% if this could be written in Syslisp, it would look something like this:
%
% syslsp procedure CompiledCallingInterpreted IDOfFunction;
% begin scalar LForm, LArgs, N, Result;
%     LForm := get(IDOfFunction, '!*LambdaLink);
%     LArgs := cadr LForm;
%     LForm := cddr LForm;
%     N := 1;
%     while PairP LArgs do
%     <<  LBind1(car LArgs, ArgumentRegister[N];
%         LArgs := cdr LArgs;
%         N := N + 1 >>;
%     Result := EvProgN LForm;
%     UnBindN(N - 1);
%     return Result;
% end;

(lap '((*entry compiledcallinginterpretedaux expr 0) 
       % link for lambda
       %
       % called by 
       %
       %        call SYMFNC+Y
       %        mov   t3,idnumber
       %
       % SYMFNC+Y:
       %        COMPILEDCALLINGINTERPRETED
       %
       (*move (reg t3) (reg t2))
       (*move (reg t3) (reg t1))
       (sll (reg t1) (reg t1) 2)
       (*mkitem (reg t2) (wconst btr-tag))        % make stack mark for btrace

       (*wplus2 (reg t1) ($fluid symprp))            % Prop list address
       (*move (memory (reg t1) (wconst 0))        % Property list
	      (reg t1))
LOOPFINDPROP
       (*jumpnottype (label propnotfound) (reg t1) pair-tag)
	                                   % make sure prop list is a pair
       (*move (car (reg t1)) (reg at))     % get car of prop list
       (*move (cdr (reg t1)) (reg t1))     % cdr down
       (*jumpnottype (label LOOPFINDPROP) (reg at)  pair-tag)
       (*move (car (reg at)) (reg t3))     % yes, look at car
       (*jumpnoteq (label loopfindprop) (reg t3) '*lambdalink)
       (*move (cdr (reg at)) (reg t1))     % yes, get lambda form
       (*jcall fastlambdaapply)

%       At this point, (reg t1) <- lambda function to be called.

(*entry fastapply expr 0)
 
       % Apply with arguments loaded
       %
       % Cadded with arguments in the registers and functional form in t1.
 
       %(*move (reg t1) (reg 1)) (*link hook expr 1) (*link console-newline expr 0)
       (andi (reg t2) (reg t1) 7)        % Tag of function into T2
       (sll (reg t2) (reg t2) 2)
       (and    (reg t3) (reg t1) (reg infmask))  % Inf of function into T1
 
       (*jumpnoteq (label notanid) (reg t2) (wconst oio-tag))
       (andi (reg t2) (reg t1) 255)       % oio-tag
       (sll (reg t2) (reg t2) 2)
       (*jumpnoteq (label notanid) (reg t2) (wconst id-tag))
       (srl (reg t1) (reg t1) 8)          % id number
       % ID: Link through function cell
       (srl (reg t3) (reg t1) 2)          % link info
       (*wplus2  (reg t1) (fluid symfnc))
       (lw (reg t1) (deferred (reg t1)))
       (nop)
       (jr (reg t1))
       (nop)
 
NOTANID(*jumpnoteq (label notacodepointer) (reg t2) (wconst sdo-tag))
       (*move (displacement (reg t3) 0) (reg t2))
       (andi (reg t2) (reg t2) 255)
       (sll (reg t2) (reg t2) 2)
       (*jumpnoteq (label notacodepointer) (reg t2) (wconst hcode-tag))
 
       % Code pointer: jump direct
        (*move (displacement (reg t3) 4) (reg t1))
	(jr (reg t1))

NOTACODEPOINTER
       (*jumpnoteq (label illegalfunctionalform) (reg t2) (wconst pair-tag))
 
       % Pair: make sure it's a lambda, then call FASTLAMBDAPPLY.
 
       (*move (memory (reg t1) (wconst 0)) (reg t2)) % CAR of the inf field.
       (*jumpnoteq (label illegalfunctionalform) (reg t2) 'lambda)
 
       (*jcall fastlambdaapply)         % (reg t1) <- lambda function
 
ILLEGALFUNCTIONALFORM
       (*move '"Illegal functional form in Apply" (reg 1))
       (*move (reg t1) (reg 2))
       (*call list2)
       (*jcall stderror)

(*entry fastlambdaapply expr 0)            % called from FastApply
	(*alloc 6)
	(*move  (reg t1) (frame 2))

	(*move (cdr (frame 2)) (frame 2))     % get (cdr of lambda form
	(*move (cdr (frame 2)) (frame 1))     % save cddr in (reg t1)
	(*move (car (frame 2)) (frame 2))     % cadr of lambda form == arg list

	(*move (reg bndstkptr) (frame 6))    % a copy for restoring
	(*move (frame 2) (reg at)) 
%
%       The first argument
%
	(*jumpnottype (label DONEBINDINGFORMALS) (reg at) pair-tag)
	(*wplus2 (reg bndstkptr) (wconst 2))
	(*jumpwgeq (label BINDINGOVERFLOW) (reg bndstkptr)
				 (reg bndstkupperbound))
	(*move (car (reg at)) (reg t1))
	(*move (cdr (reg at)) (reg at))
	(srl (reg t1) (reg t1) 8 )       % (reg t5) <- id number
	(*move (reg t1) (memory (reg bndstkptr) (wconst -1)))
	(*wplus2 (reg t1) ($fluid symval))
	(*move (memory (reg t1) (wconst 0)) (memory (reg bndstkptr) (wconst 0)))
	(*move (reg 1) (memory (reg t1) (wconst 0)))
%
%       The second argument
%
	(*jumpnottype (label DONEBINDINGFORMALS) (reg at) pair-tag)
	(*wplus2 (reg bndstkptr) (wconst 2))
	(*jumpwgeq (label BINDINGOVERFLOW) (reg bndstkptr) (reg bndstkupperbound))
	(*move (car (reg at)) (reg t1))
	(*move (cdr (reg at)) (reg at))
        (srl (reg t1) (reg t1) 8 )       % (reg t5) <- id number
	(*move (reg t1) (memory (reg bndstkptr) (wconst -1)))
	(*wplus2 (reg t1) ($fluid symval))
	(*move (memory (reg t1) (wconst 0)) (memory (reg bndstkptr) (wconst 0)))
	(*move (reg 2) (memory (reg t1) (wconst 0)))
%
%       The third argument
%
	(*jumpnottype (label DONEBINDINGFORMALS) (reg at) pair-tag)
	(*wplus2 (reg bndstkptr) (wconst 2))
	(*jumpwgeq (label BINDINGOVERFLOW) (reg bndstkptr) (reg bndstkupperbound))
	(*move (car (reg at)) (reg t1))
	(*move (cdr (reg at)) (reg at))
        (srl (reg t1) (reg t1) 8 )       % (reg t5) <- id number
	(*move (reg t1) (memory (reg bndstkptr) (wconst -1)))
	(*wplus2 (reg t1) ($fluid symval))
	(*move (memory (reg t1) (wconst 0)) (memory (reg bndstkptr) (wconst 0)))
	(*move (reg 3) (memory (reg t1) (wconst 0)))
%
%       The fourth argument
%
	(*jumpnottype (label DONEBINDINGFORMALS) (reg at) pair-tag)
	(*wplus2 (reg bndstkptr) (wconst 2))
	(*jumpwgeq (label BINDINGOVERFLOW) (reg bndstkptr) (reg bndstkupperbound))
	(*move (car (reg at)) (reg t1))
	(*move (cdr (reg at)) (reg at))
        (srl (reg t1) (reg t1) 8 )       % (reg t5) <- id number
	(*move (reg t1) (memory (reg bndstkptr) (wconst -1)))
	(*wplus2 (reg t1) ($fluid symval))
	(*move (memory (reg t1) (wconst 0)) (memory (reg bndstkptr) (wconst 0)))
	(*move (reg 4) (memory (reg t1) (wconst 0)))
%
%       The fifth argument
%
	(*jumpnottype (label DONEBINDINGFORMALS) (reg at) pair-tag)
	(*wplus2 (reg bndstkptr) (wconst 2))
	(*jumpwgeq (label BINDINGOVERFLOW) (reg bndstkptr) (reg bndstkupperbound))
	(*move (car (reg at)) (reg t1))
	(*move (cdr (reg at)) (reg at))
        (srl (reg t1) (reg t1) 8 )       % (reg t5) <- id number
	(*move (reg t1) (memory (reg bndstkptr) (wconst -1)))
	(*wplus2 (reg t1) ($fluid symval))
	(*move (memory (reg t1) (wconst 0)) (memory (reg bndstkptr) (wconst 0)))
	(*move (reg 5) (memory (reg t1) (wconst 0)))
%
%       The sixth argument
%
	(*jumpnottype (label DONEBINDINGFORMALS) (reg at) pair-tag)
	(*wplus2 (reg bndstkptr) (wconst 2))
	(*jumpwgeq (label BINDINGOVERFLOW) (reg bndstkptr) (reg bndstkupperbound))
	(*move (car (reg at)) (reg t1))
	(*move (cdr (reg at)) (reg at))
        (srl (reg t1) (reg t1) 8 )       % (reg t5) <- id number
	(*move (reg t1) (memory (reg bndstkptr) (wconst -1)))
	(*wplus2 (reg t1) ($fluid symval))
	(*move (memory (reg t1) (wconst 0)) (memory (reg bndstkptr) (wconst 0)))
	(*move (reg 6) (memory (reg t1) (wconst 0)))
%
%       The seventh argument
%
	(*jumpnottype (label DONEBINDINGFORMALS) (reg at) pair-tag)
	(*wplus2 (reg bndstkptr) (wconst 2))
	(*jumpwgeq (label BINDINGOVERFLOW) (reg bndstkptr) (reg bndstkupperbound))
	(*move (car (reg at)) (reg t1))
	(*move (cdr (reg at)) (reg at))
        (srl (reg t1) (reg t1) 8 )       % (reg t5) <- id number
	(*move (reg t1) (memory (reg bndstkptr) (wconst -1)))
	(*wplus2 (reg t1) ($fluid symval))
	(*move (memory (reg t1) (wconst 0)) (memory (reg bndstkptr) (wconst 0)))
	(*move (reg 7) (memory (reg t1) (wconst 0)))
%
%       The eighth argument
%
	(*jumpnottype (label DONEBINDINGFORMALS) (reg at) pair-tag)
	(*wplus2 (reg bndstkptr) (wconst 2))
	(*jumpwgeq (label BINDINGOVERFLOW) (reg bndstkptr) (reg bndstkupperbound))
	(*move (car (reg at)) (reg t1))
	(*move (cdr (reg at)) (reg at))
        (srl (reg t1) (reg t1) 8 )       % (reg t5) <- id number
	(*move (reg t1) (memory (reg bndstkptr) (wconst -1)))
	(*wplus2 (reg t1) ($fluid symval))
	(*move (memory (reg t1) (wconst 0)) (memory (reg bndstkptr) (wconst 0)))
	(*move (reg 8) (memory (reg t1) (wconst 0)))
%
%       The nineth argument
%
	(*jumpnottype (label DONEBINDINGFORMALS) (reg at) pair-tag)
	(*wplus2 (reg bndstkptr) (wconst 2))
	(*jumpwgeq (label BINDINGOVERFLOW) (reg bndstkptr) (reg bndstkupperbound))
	(*move (car (reg at)) (reg t1))
	(*move (cdr (reg at)) (reg at))
        (srl (reg t1) (reg t1) 8 )       % (reg t5) <- id number
	(*move (reg t1) (memory (reg bndstkptr) (wconst -1)))
	(*wplus2 (reg t1) ($fluid symval))
	(*move (memory (reg t1) (wconst 0)) (memory (reg bndstkptr) (wconst 0)))
	(*move (reg 9) (memory (reg t1) (wconst 0)))
%
%       The tenth argument
%
	(*jumpnottype (label DONEBINDINGFORMALS) (reg at) pair-tag)
	(*wplus2 (reg bndstkptr) (wconst 2))
	(*jumpwgeq (label BINDINGOVERFLOW) (reg bndstkptr) (reg bndstkupperbound))
	(*move (car (reg at)) (reg t1))
	(*move (cdr (reg at)) (reg at))
        (srl (reg t1) (reg t1) 8 )       % (reg t5) <- id number
	(*move (reg t1) (memory (reg bndstkptr) (wconst -1)))
	(*wplus2 (reg t1) ($fluid symval))
	(*move (memory (reg t1) (wconst 0)) (memory (reg bndstkptr) (wconst 0)))
	(*move (reg 10) (memory (reg t1) (wconst 0)))
%
%       The eleventh argument
%
	(*jumpnottype (label DONEBINDINGFORMALS) (reg at) pair-tag)
	(*wplus2 (reg bndstkptr) (wconst 2))
	(*jumpwgeq (label BINDINGOVERFLOW) (reg bndstkptr) (reg bndstkupperbound))
	(*move (car (reg at)) (reg t1))
	(*move (cdr (reg at)) (reg at))
        (srl (reg t1) (reg t1) 8 )       % (reg t5) <- id number
	(*move (reg t1) (memory (reg bndstkptr) (wconst -1)))
	(*wplus2 (reg t1) ($fluid symval))
	(*move (memory (reg t1) (wconst 0)) (memory (reg bndstkptr) (wconst 0)))
	(*move (reg 11) (memory (reg t1) (wconst 0)))
%
%       The twelveth argument
%
	(*jumpnottype (label DONEBINDINGFORMALS) (reg at) pair-tag)
	(*wplus2 (reg bndstkptr) (wconst 2))
	(*jumpwgeq (label BINDINGOVERFLOW) (reg bndstkptr) (reg bndstkupperbound))
	(*move (car (reg at)) (reg t1))
	(*move (cdr (reg at)) (reg at))
        (srl (reg t1) (reg t1) 8 )       % (reg t5) <- id number
	(*move (reg t1) (memory (reg bndstkptr) (wconst -1)))
	(*wplus2 (reg t1) ($fluid symval))
	(*move (memory (reg t1) (wconst 0)) (memory (reg bndstkptr) (wconst 0)))
	(*move (reg 12) (memory (reg t1) (wconst 0)))
%
%       The thirteenth argument
%
	(*jumpnottype (label DONEBINDINGFORMALS) (reg at) pair-tag)
	(*wplus2 (reg bndstkptr) (wconst 2))
	(*jumpwgeq (label BINDINGOVERFLOW) (reg bndstkptr) (reg bndstkupperbound))
	(*move (car (reg at)) (reg t1))
	(*move (cdr (reg at)) (reg at))
        (srl (reg t1) (reg t1) 8 )       % (reg t5) <- id number
	(*move (reg t1) (memory (reg bndstkptr) (wconst -1)))
	(*wplus2 (reg t1) ($fluid symval))
	(*move (memory (reg t1) (wconst 0)) (memory (reg bndstkptr) (wconst 0)))
	(*move (reg 13) (memory (reg t1) (wconst 0)))
%
%       The fourteenth argument
%
	(*jumpnottype (label DONEBINDINGFORMALS) (reg at) pair-tag)
	(*wplus2 (reg bndstkptr) (wconst 2))
	(*jumpwgeq (label BINDINGOVERFLOW) (reg bndstkptr) (reg bndstkupperbound))
	(*move (car (reg at)) (reg t1))
	(*move (cdr (reg at)) (reg at))
        (srl (reg t1) (reg t1) 8 )       % (reg t5) <- id number
	(*move (reg t1) (memory (reg bndstkptr) (wconst -1)))
	(*wplus2 (reg t1) ($fluid symval))
	(*move (memory (reg t1) (wconst 0)) (memory (reg bndstkptr) (wconst 0)))
	(*move (reg 14) (memory (reg t1) (wconst 0)))
%
%
%       The fifteenth argument
%
	(*jumpnottype (label DONEBINDINGFORMALS) (reg at) pair-tag)
	(*wplus2 (reg bndstkptr) (wconst 2))
	(*jumpwgeq (label BINDINGOVERFLOW) (reg bndstkptr) (reg bndstkupperbound))
	(*move (car (reg at)) (reg t1))
	(*move (cdr (reg at)) (reg at))
        (srl (reg t1) (reg t1) 8 )       % (reg t5) <- id number
	(*move (reg t1) (memory (reg bndstkptr) (wconst -1)))
	(*wplus2 (reg t1) ($fluid symval))
	(*move (memory (reg t1) (wconst 0)) (memory (reg bndstkptr) (wconst 0)))
	(*move (reg 15) (memory (reg t1) (wconst 0)))
%
%       The sixteenth argument
%
	(*jumpnottype (label DONEBINDINGFORMALS) (reg at) pair-tag)
	(*wplus2 (reg bndstkptr) (wconst 2))
	(*jumpwgeq (label BINDINGOVERFLOW) (reg bndstkptr) (reg bndstkupperbound))
	(*move (car (reg at)) (reg t1))
	(*move (cdr (reg at)) (reg at))
        (srl (reg t1) (reg t1) 8 )       % (reg t5) <- id number
	(*move (reg t1) (memory (reg bndstkptr) (wconst -1)))
	(*wplus2 (reg t1) ($fluid symval))
	(*move (memory (reg t1) (wconst 0)) (memory (reg bndstkptr) (wconst 0)))
	(*move (reg 16) (memory (reg t1) (wconst 0)))

	(*move '"Too many arguments to function" (reg 1))
	(*dealloc 6)
	(*jcall stderror)

BINDINGOVERFLOW
	(*dealloc 6)
	(*jcall bstackoverflow)             % then error

DONEBINDINGFORMALS
	(*move (frame 1) (reg 1))          % get cddr of lambda form to eval
	(*call evprogn)                    % implicit progn
	(*move (reg 1) (frame 1))          % save result, get old bind stk ptr
	(*move (frame 6) (reg 1))
	(*call restoreenvironment)
	(*move (frame 1) (reg 1))
	(*exit 6)                            % and return

PROPNOTFOUND
	(*move (quote "*LAMBDALINK property not found for interpreted function")
	       (reg 1))
	(*linke 6 stderror expr 1)
)de lambdaapply (fn args)
  % Fn is Lambda, unevaled Args
  (if (not (and (pairp fn) (weq (car fn) 'lambda)))
    (continuableerror '1104 '"Ill-formed function expression"
	              (cons fn (foreach x in args collect (mkquote x))))
    (prog (formals n result)
	  (setq formals (cadr fn))
	  (setq n 0)
	  (while (and (pairp formals) (pairp args))
	    (lbind1 (car formals) (car args))
	    (setq formals (cdr formals))
	    (setq args (cdr args))
	    (setq n (wplus2 n 1)))
	  (when (or (pairp formals) (pairp args))
	    (return (continuableerror '1204 '"Argument number mismatch"
	             (cons fn (foreach x in args collect (mkquote x))))))
	  (setq result (evprogn (cddr fn)))
	  (when (wneq n 0)
	    (unbindn n))
	  (return result))))

(lap '((*entry xlist5 expr 5)
	(lui (reg t2) 16#4000)         % pair-tag
	(or (reg t3) (reg t2) (reg r16)) % the result
	(addi (reg t1) (reg t3) 2)   % first pair
        (sll (reg t4) (reg r16) 2)
	(sw (reg 1)  (indexed (reg t4) 0))
	(sw (reg t1) (indexed (reg t4) 4))
	(addi(reg t1) (reg t3) 4)       % second pair
	(sw (reg 2)  (indexed (reg t4) 8))
	(sw (reg t1) (indexed (reg t4) 12))
	(addi (reg t1) (reg t3) 6)       % third pair
	(sw (reg 3)  (indexed (reg t4) 16))
	(sw (reg t1) (indexed (reg t4) 20))
	(addi (reg t1) (reg t3) 8)       % fourth pair
	(sw (reg 4)  (indexed (reg t4) 24))
	(sw (reg t1) (indexed (reg t4) 28))
	(sw (reg 5)  (indexed (reg t4) 32)) % fifth pair
	(*wplus2 (reg r16) 10) 
	(sub (reg t1) (reg r16) (reg r17))
	(bltz (reg t1) enough)
        (sw (reg nil) (indexed (reg t4) 36))
	(*xalloc 1) 
        (*move (reg t3) (frame 1))
	(*link !%reclaim expr 0) 
	(*move (frame 1) (reg t3))  % Restore Result; all other Regs are not of
	(*xdealloc 1)                % interest any more 
  
    enough
	(jr (reg returnaddr))
	(*move (reg t3) (reg 1)) 
)   )

(lap '((*entry xlist4 expr 5)
        (lui (reg t2) 16#4000)         % pair-tag
	(or (reg t3) (reg t2) (reg r16)) % the result
	(addi (reg t1) (reg t3) 2)   % first pair
        (sll (reg t4) (reg r16) 2)
	(sw (reg 1)  (indexed (reg t4) 0))
	(sw (reg t1) (indexed (reg t4) 4))
	(addi(reg t1) (reg t3) 4)       % second pair
	(sw (reg 2)  (indexed (reg t4) 8))
	(sw (reg t1) (indexed (reg t4) 12))
	(addi (reg t1) (reg t3) 6)       % third pair
	(sw (reg 3)  (indexed (reg t4) 16))
	(sw (reg t1) (indexed (reg t4) 20))
	(sw (reg 4)  (indexed (reg t4) 24))
	(*wplus2 (reg r16) 8) 
	(sub (reg t1) (reg r16) (reg r17))
	(bltz (reg t1) enough)
	(sw (reg nil) (indexed (reg t4) 28))
	(*xalloc 1) 
	(*move (reg t3) (frame 1))
	(*link !%reclaim expr 0) 
	(*move (frame 1) (reg t3))  % Restore Result; all other Regs are not of
	(*xdealloc 1)               % interest any more 
  
    enough
	(jr (reg returnaddr))
	(*move (reg t3) (reg 1)) 
)   )

(lap '((*entry xlist3 expr 5)
        (lui (reg t2) 16#4000)         % pair-tag
	(or (reg t3) (reg t2) (reg r16)) % the result
	(addi (reg t1) (reg t3) 2)   % first pair
        (sll (reg t4) (reg r16) 2)
	(sw (reg 1)  (indexed (reg t4) 0))
	(sw (reg t1) (indexed (reg t4) 4))
	(addi(reg t1) (reg t3) 4)       % second pair
	(sw (reg 2)  (indexed (reg t4) 8))
	(sw (reg t1) (indexed (reg t4) 12))
	(sw (reg 3)  (indexed (reg t4) 16))
	(*wplus2 (reg r16) 6) 
	(sub (reg t1) (reg r16) (reg r17))
	(bltz (reg t1) enough)
	(sw (reg nil) (indexed (reg t4) 20))
	(*xalloc 1) 
	(*move (reg t3) (frame 1))
	(*link !%reclaim expr 0) 
	(*move (frame 1) (reg t3))  % Restore Result; all other Regs are not of
	(*xdealloc 1)               % interest any more 
  
    enough
	(jr (reg returnaddr))
	(*move (reg t3) (reg 1)) 
)   )

(lap '((*entry xlist2 expr 5)
        (lui (reg t2) 16#4000)         % pair-tag
	(or (reg t3) (reg t2) (reg r16)) % the result
	(addi (reg t1) (reg t3) 2)   % first pair
        (sll (reg t4) (reg r16) 2)
	(sw (reg 1)  (indexed (reg t4) 0))
	(sw (reg t1) (indexed (reg t4) 4))
	(sw (reg 2)  (indexed (reg t4) 8))
	(*wplus2 (reg r16) 4) 
	(sub (reg t1) (reg r16) (reg r17))
	(bltz (reg t1) enough)
	(sw (reg nil) (indexed (reg t4) 12))
	(*xalloc 1) 
	(*move (reg t3) (frame 1))
	(*link !%reclaim expr 0) 
	(*move (frame 1) (reg t3))  % Restore Result; all other Regs are not of
	(*xdealloc 1)               % interest any more 
  
    enough
	(jr (reg returnaddr))
	(*move (reg t3) (reg 1)) 
)   )
