%
% CAL_SYSCALLS.RED - Calendar/time related routines.
%
% Author:      G. Q. Maguire Jr.
%              Computer Science Dept.
%              University of Utah
% Date:        2 November 1982
% Copyright (c) 1982 G. Q. Maguire Jr.
%
%13-Mar-84, JWP, Got rid of some spurious fluids
%13-MAR-84, JWP, Fixed to handle status codes correctly
% 2-MAR-83, JWP, Changed to PutObjPointer syscall package, and moved PROC1
%                stuff to PROC1_SYSCALLS.RED
%

% ---------------------------------------------------------------------
% Calendar and Time related routines
% ---------------------------------------------------------------------

% --------------------------------------------------
% from  CAL.INS.PAS  calendar maintenance routines - insert file


%                 cal_!$bad_syntax        = 16#00150001,
%                 cal_!$out_of_range      = 16#00150002,
%                 cal_!$empty_string      = 16#00150003,
%                 cal_!$unknown_timezone  = 16#00150004,
%                 cal_!$invalid_tzdif     = 16#00150005;



%exported WCONST  cal_!$string_size = 80;


%TYPE   cal_!$string_t = ARRAY [1..cal_!$string_size] OF char ;
%
%       cal_!$tz_name_t = ARRAY [1..4] OF char ;   % timezone name
%
%       cal_!$timedate_rec_t = PACKED RECORD   % returned from
                                               % cal_!$decode_time
%           year:    integer ;
%           month:   integer ;
%           day:     integer ;
%           hour:    integer ;
%           minute:  integer ;
%           second:  integer
%           END ;

% cal_!$weekday_t = (cal_!$sun, cal_!$mon, cal_!$tue, cal_!$wed, cal_!$thu,
%                         cal_!$fri, cal_!$sat) ;
%Wconst cal_!$sun = 0,
%       cal_!$mon = 1,
%       cal_!$tue = 2,
%       cal_!$wed = 3,
%       cal_!$thu = 4,
%       cal_!$fri = 5,
%       cal_!$sat = 6 ;


%       cal_!$timezone_rec_t = PACKED RECORD
%           utc_delta:  integer ;           % # minutes from UTC
%           tz_name:  cal_!$tz_name_t ;      % timezone name
%           drift:  time_!$clock_t ;         % drift adjustment made by user
%           END ;


%   cal_!$dpval_t = ARRAY [1..2] OF linteger ;   % temp, 'til pascal has fp


(de cal_decode_ascii_time (timestring) 
(prog (status hour minute second) 
                                        % ASCII string to be decoded
  (putarg 1 timestring '(string))       %  cal_!$string_size
  (putarg 2 (stringlength timestring) '(integer16)) 	% string length in bytes
  (putarg 3 hour '(integer16))          % space for number
  (putarg 4 minute '(integer16)) 
  (putarg 5 second '(integer16)) 
  (cleararg 6) 

  (syscall 'cal_$decode_ascii_time 6) 

  (setq status (getarg 6 '(integer32) '(fixn))) 	% 32 bit status code

  (cond ((equal status 0) 
    (progn 
            (apolloresetstatus) 
            (setq hour (getarg 3 '(integer16) '(inum))) 	% returned time
            (setq minute (getarg 4 '(integer16) '(inum))) 
            (setq second (getarg 5 '(integer16) '(inum))) 
            (return (list hour minute second)) nil)) (t 
         
    (return (apolloerror status))))))


(de cal_ecode_ascii_date (datestring) 
(prog (status year month day) 
                                        % ASCII string to be decoded
  (putarg 1 datestring '(string))       % cal_!$string_size
  (putarg 2 (stringlength datestring) '(integer16)) 	% string length in bytes
  (putarg 3 year '(integer16))          % space for number
  (putarg 4 month '(integer16)) 
  (putarg 5 day '(integer16)) 
  (cleararg 6) 

  (syscall 'cal_$decode_ascii_date 6) 

  (setq status (getarg 6 '(integer32) '(fixn))) 	% 32 bit status code

  (cond ((equal status 0) 
    (progn 
            (apolloresetstatus) 
            (setq year (getarg 3 '(integer16) '(inum))) 	% returned Date
            (setq month (getarg 4 '(integer16) '(inum))) 
            (setq day (getarg 5 '(integer16) '(inum))) 
            (return (list year month day)) nil)) (t 
         
    (return (apolloerror status))))))


(de cal_decode_ascii_tzdif (datestring) 
(prog (status tz_diff tz_name) 
  (setq tz_name (mkstring 256 32)) 
                                        % ASCII string to be decoded
  (putarg 1 datestring '(string))       % cal_!$string_size
  (putarg 2 (stringlength datestring) '(integer16)) 	% string length in bytes
  (cleararg 3) 
  (cleararg 4) 
  (cleararg 5) 

  (syscall 'cal_$decode_ascii_tzdif 5) 

  (setq status (getarg 5 '(integer32) '(fixn))) 	% 32 bit status code

  (cond ((equal status 0) 
    (progn 
            (apolloresetstatus) 
            (setq tz_diff (getarg 3 '(integer16) '(inum))) 	% diff in minutes
                                                      % from UTC
            (setq tz_name (getarg 4 (cons 'string 'cal_$string_size) 
                               '(string))) 	% name of Timezone
                                                        % if specified
            (return (list tz_diff tz_name)) nil)) (t 
         
    (return (apolloerror status))))))


(de cal_decode_time (highprecisionclock) 
(prog (decodedclock year month day hour minute second) 

  (setq decodedclock (gthalfwords 5))   % allocate space

  (putobjpointer 1 highprecisionclock)  % clock to be decoded
  (putobjpointer 2 decodedclock) 

  (syscall 'cal_$decode_time 2) 

  (setq year (gethalfword decodedclock 0)) 
  (setq month (gethalfword decodedclock 1)) 
  (setq day (gethalfword decodedclock 2)) 
  (setq hour (gethalfword decodedclock 3)) 	% decoded time & date
  (setq minute (gethalfword decodedclock 4)) 
  (setq second (gethalfword decodedclock 5)) 
  (apolloresetstatus)                   % no bad status return

  (return (list year month day hour minute second))))


                                        %
(de cal_encode_time (timerecord) 
%  encode time -> secs past 1/1/80
%
% Need to take as arg list of year, mon, day, etc.
%
(prog (clockrecord highprecisionclock) 
  (setq highprecisionclock (gthalfwords 3)) 	% allocate space

  (putobjpointer 1 timerecord)          % clock to be encoded
  (putobjpointer 2 highprecisionclock) 

  (syscall 'cal_$encode_time 2) 
  (setq highprecisionclock (getarg 2 '(integer16 . 3))) 

  (apolloresetstatus)                   % no bad status return
  (return highprecisionclock)))


(de cal_decode_time nil 
(prog (decodedclock year month day hour minute second) 

  (setq decodedclock (gthalfwords 5))   % allocate space

  (putobjpointer 1 decodedclock) 

  (syscall 'cal_$decode_local_time 2) 

  (setq year (gethalfword decodedclock 0)) 
  (setq month (gethalfword decodedclock 1)) 
  (setq day (gethalfword decodedclock 2)) 
  (setq hour (gethalfword decodedclock 3)) 	% decoded time & date
  (setq minute (gethalfword decodedclock 4)) 
  (setq second (gethalfword decodedclock 5)) 

  (apolloresetstatus)                   % no bad status return

  (return (list year month day hour minute second))))



(de cal_weekday (year month day) 
(prog (year month day weekday) 
  (putarg 1 year '(integer16))          % space for number
  (putarg 2 month '(integer16)) 
  (putarg 3 day '(integer16)) 

  (setq weekday (syscall 'cal_$weekday 3)) 

  (apolloresetstatus)                   % no bad status return

 (return weekday)))                     % as an enumerated type [0..6]


(de cal_apply_local_offset (timeclockt) 
(prog nil 
  (putobjpointer 1 timeclockt)          % space for number

  (syscall 'cal_$apply_local_offset 1)  % apply local offset to a
                                         % time_!$clock_t
  (apolloresetstatus)                   % no bad status return

 (return timeclockt)))


(de cal_get_local_time nil 
(prog (timeclockt) 
  (setq timeclockt (gthalfwords 3))     % Integer*2 (3)
  (putobjpointer 1 timeclockt)          % space for number

  (syscall 'cal_$get_local_time 1)      %get clock w/ local adjustment

  (apolloresetstatus)                   % no bad status return

 (return timeclockt)))



%
%PROCEDURE  cal_!$write_timezone (           % write tz onto boot volume
%               IN  tz_rec:  cal_!$timezone_rec_t ;
%               OUT status:  status_!$t
%           ) ;  EXTERN ;
%
%

(de cal_sec_to_clock (numberofseconds) 
(prog (timeclockt) 
  (setq timeclockt (gthalfwords 3))     % Integer*2 (3)
  (putarg 1 numberofseconds '(integer32)) 
  (putobjpointer 2 timeclockt)          % space for result

  (syscall 'cal_$sec_to_clock 1)        % convert seconds to clockt

  (apolloresetstatus)                   % no bad status return

 (return timeclockt)))


(de cal_clock_to_sec (timeclockt) 
(prog (numberofseconds) 
  (putobjpointer 1 timeclockt) 
                                        % convert clockt to seconds
  (setq numberofseconds (syscall 'cal_$clock_to_sec 1)) 

  (apolloresetstatus)                   % no bad status return

 (return numberofseconds)))


%
%PROCEDURE  cal_!$get_info (                 % read calendar info from os
%               OUT  tz_rec:  cal_!$timezone_rec_t
%           ) ;  EXTERN ;
%
%
(de cal_float_clock                     % convert time_!$clock_t to d.p. floating
                (clock)                 %  time_!$clock_t ;
(prog (dpval) 
  (putobjpointer 1 clock) 
  (cleararg 2) (syscall 
  'cal_$float_clock 2) 
  (setq dpval (getarg 2 '(real64) '(lispfloat))) 
  (apolloresetstatus)                   % no bad status return
  (return dpval)))

%
(de cal_add_clock (clock1 clock2) 
% Clock1 and Clock2 are both TimeClockT formats
(prog nil 
  (putobjpointer 1 clock1) 
  (putobjpointer 2 clock2) 

  (syscall 'cal_$add_clock 2)           % add 2 clocks

  (apolloresetstatus)                   % no bad status return

  (return clock1)))


(de cal_sub_clock (clock1 clock2) 
% Clock1 and Clock2 are both TimeClockT formats
(prog nil 
  (putobjpointer 1 clock1) 
  (putobjpointer 2 clock2) 

  (apolloresetstatus)                   % no bad status return

  (return (syscall 'cal_$sub_clock 2))))% add 2 clocks




(de cal_cmp_clock (clock1 clock2) 
% Clock1 and Clock2 are both TimeClockT formats
% compare 2 clocks, return:
%   1 if clock1 > clock2
%   0 if clock1 = clock2
%  -1 if clock1 < clock2
(prog (positivedifference) 
  (putobjpointer 1 clock1) 
  (putobjpointer 2 clock1) 

  (setq positivedifference (syscall 'cal_$cmp_clock 2)) 

  (apolloresetstatus)                   % no bad status return
  (return positivedifference)))


% --------------------------------------------------
% from  TIME.INS.PAS   customer-callable timer routines


%Exported WCONST time_!$no_q_entry = 16#000D0001,  % error from time_$advance
%                time_!$not_found =  16#000D0002,  % entry to be canceled not found
%                time_!$wait_quit =  16#000D0003,  % wait interrupted by quit fault
%                time_!$bad_int   =  16#000D0004,  % bad timer interrupt
%                time_!$bad_key   =  16#000D0005;  % bad key to time_$get_ec

%TYPE   time_$rel_abs_t = (time_$relative, time_$absolute) ;
%       time_$key_t     = (time_$clockh_key) ;
%
(de time_clock nil 
(prog (timeclockt) 
  (setq timeclockt (make-halfwords 3))  % Integer*2 (3)
  (putarg 1 timeclockt '(integer16 . 3)) 	% space for number
  (cleararg 2) 
  (cleararg 3) 

  (syscall 'time_$clock 3)              % read the whole clock

  (setq timeclockt (getarg 1 '(integer16 . 3) '(integer16 . 3))) 
  (apolloresetstatus)                   % no bad status return
 (return timeclockt)))


%
%PROCEDURE  time_$wait (    rel_abs:  time_$rel_abs_t ;
%                       IN  exp_time:  time_$clock_t ;
%                       OUT status:  status_$t
%                      ) ; EXTERN ;
%
%PROCEDURE time_$get_ec(IN  key: time_$key_t;
%                       OUT ecp   : ec2_$ptr_t;
%                       OUT status: status_$t); EXTERN;
% --------------------------------------------------

