%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:           Helferlein.SL
% Description:    various useful access functions
% Author:         Herbert Melenk and Winfried Neun, ZIB Berlin
% Created:        5 September 1986
% Status:         Experimental (Do Not Distribute), CRAY version only
% Mode:           Lisp
% Package:        Utilities
%
% copyright (c) 1987, Konrad Zuse-Zentrum Berlin, all rights reserved
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
(compiletime (setq *syslisp t))
(compiletime (load inum if-system))
 
(de memo (x) (getmem x))
 
(compiletime
(if_system Cray-2
 (put 'localmemo 'opencode '((move (reg a6) (reg 1))
                            (load (reg 1) (indexed (reg a6) locmem))))))
 
(de info (x) (inf x))
 
(de valo (x) (symval (inf x)))
 
(de namo (x) (symnam (inf x)))
 
(de fnco (x) (wgetv symfnc (inf x)))
 
(de propo (x) (symprp (inf x)))
 
(de hasho (x) (halfword hashtable x))
 
(de printo (x) (putoct x) (terminalwritechar 32 32)
              (terminalwritechar 32 32)
              (terminalwritechar 32 32)
 
            (case (tag x)
                 ((posint-tag negint-tag)
                              (progn (putint x) (console-newline)))
                 ((fixnum-tag) (console-print-string "<fixnum>"))
                 ((bignum-tag) (console-print-string "<bignum>"))
                 ((floatnum-tag) (console-print-string "<float>"))
                 ((bytes-tag) (console-print-string "<bytes>"))
                 ((halfwords-tag) (console-print-string "<halfwords>"))
                 ((words-tag) (console-print-string "<words>"))
                 ((vector-tag) (console-print-string "<vector>"))
                 ((pair-tag) (console-print-string "<pair>"))
                 ((evector-tag) (console-print-string "<evector>"))
                 ((code-tag) (console-print-string "<code>"))
                 ((unbound-tag) (console-print-string "<unbound>"))
                 ((btr-tag) (console-print-string "<backtrace>"))
                 ((forward-tag) (console-print-string "<forward>"))
                 ((hvect-tag) (console-print-string "<h vector>"))
                 ((hwords-tag) (console-print-string "<h words>"))
                 ((hhalfwords-tag)(console-print-string "<h halfwords>"))
                 ((hbytes-tag) (console-print-string "<h bytes>"))
                 ((id-tag)(if (and (wlessp (inf x) maxsymbols)
                                   (symnam (inf x)))
                                 (console-print-string (symnam (inf x)))
                                 (console-newline)))
                 ((string-tag)(if (and (wlessp (inf x) stack)
                                       (wlessp (strlen x) 100))
                                   (progn
                                     (terminalwritechar 34 34)
                                     (console-print-string x))
                                   (console-newline)))
                 (nil (console-newline))
                  )
T )
 
(de dumpo (x n)
   (prog (outputbase* addr)
        (setq outputbase* 8)
        (when (greaterp n 255) (setq n 255))
        (console-newline)
        (printo x) (console-newline)
        (ifor (from i 0 n 1)
          (do (progn
                (setq addr (wplus2 (inf x) i))
                (when (eq (wand addr  7) 0)
                          (console-newline) (putoct addr)
                          (console-print-string " ---------------"))
 
                          (printo (getmem addr))
        ) )   )
   (return t)
)  )
 
(if_system Cray-2
 (de localdumpo (x n)
   (prog (outputbase* addr)
        (setq outputbase* 8)
        (when (greaterp n 255) (setq n 255))
        (console-newline)
        (printo x) (console-newline)
        (ifor (from i 0 n 1)
          (do (progn
                (setq addr (wplus2 (inf x) i))
                (when (eq (wand addr  7) 0)
                          (console-newline) (putoct addr)
                          (console-print-string " ---------------"))
 
                          (printo (localmemo addr))
        ) )   )
   (return t)
))  )
 
(compiletime (setq *syslisp nil))
